#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main()
{
    long N,M,C; int i,j; long long suma=0,resenje;
    scanf("%ld%ld",&N,&M);
    long nizB[M+1];
    for(i=1;i<=M;i++) {
        scanf("%ld",&nizB[i]);
    }
    scanf("%ld",&C);
    long nizA[N+1];
    for(i=1;i<=N;i++) {
        nizA[i]=i;
    }

    for(i=0;i<=N-M;i++) {
        for (j=1; j<=M; j++)
            nizA[i + nizB[j]] = nizA[i + j];
    }

    for(i=1;i<=N;i++) {
        suma+=pow(C,i)*nizA[i];
    }

    resenje=suma%998244353;


    printf("%lld",resenje);
    return 0;
}